/**
 * Generated from 'examples/jsm/postprocessing/FilmPass.js'
 */

(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('three'), require('examples/jsm/postprocessing/Pass.js'), require('examples/jsm/shaders/FilmShader.js')) :
	typeof define === 'function' && define.amd ? define(['exports', 'three', 'examples/jsm/postprocessing/Pass.js', 'examples/jsm/shaders/FilmShader.js'], factory) :
	(global = global || self, factory(global.THREE = global.THREE || {}, global.THREE, global.THREE, global.THREE));
}(this, function (exports, THREE, Pass_js, FilmShader_js) { 'use strict';

	/**
	 * @author alteredq / http://alteredqualia.com/
	 */

	var FilmPass = function ( noiseIntensity, scanlinesIntensity, scanlinesCount, grayscale ) {

		Pass_js.Pass.call( this );

		if ( FilmShader_js.FilmShader === undefined )
			console.error( "FilmPass relies on FilmShader" );

		var shader = FilmShader_js.FilmShader;

		this.uniforms = THREE.UniformsUtils.clone( shader.uniforms );

		this.material = new THREE.ShaderMaterial( {

			uniforms: this.uniforms,
			vertexShader: shader.vertexShader,
			fragmentShader: shader.fragmentShader

		} );

		if ( grayscale !== undefined )	this.uniforms.grayscale.value = grayscale;
		if ( noiseIntensity !== undefined ) this.uniforms.nIntensity.value = noiseIntensity;
		if ( scanlinesIntensity !== undefined ) this.uniforms.sIntensity.value = scanlinesIntensity;
		if ( scanlinesCount !== undefined ) this.uniforms.sCount.value = scanlinesCount;

		this.fsQuad = new Pass_js.Pass.FullScreenQuad( this.material );

	};

	FilmPass.prototype = Object.assign( Object.create( Pass_js.Pass.prototype ), {

		constructor: FilmPass,

		render: function ( renderer, writeBuffer, readBuffer, deltaTime /*, maskActive */ ) {

			this.uniforms[ "tDiffuse" ].value = readBuffer.texture;
			this.uniforms[ "time" ].value += deltaTime;

			if ( this.renderToScreen ) {

				renderer.setRenderTarget( null );
				this.fsQuad.render( renderer );

			} else {

				renderer.setRenderTarget( writeBuffer );
				if ( this.clear ) renderer.clear();
				this.fsQuad.render( renderer );

			}

		}

	} );

	exports.FilmPass = FilmPass;

}));
